[ Avaa Bypassed ]




Upload:

Command:

hmhc3928@18.119.113.73: ~ $
#!/bin/bash
KEXEC=/sbin/kexec

KDUMP_KERNELVER=""
KDUMP_COMMANDLINE=""
KEXEC_ARGS=""
KDUMP_CONFIG_FILE="/etc/kdump.conf"
MKDUMPRD="/sbin/mkdumprd -f"
DRACUT_MODULES_FILE="/usr/lib/dracut/modules.txt"
SAVE_PATH=/var/crash
SSH_KEY_LOCATION="/root/.ssh/kdump_id_rsa"
INITRD_CHECKSUM_LOCATION="/boot/.fadump_initrd_checksum"
DUMP_TARGET=""
DEFAULT_INITRD=""
DEFAULT_INITRD_BAK=""
TARGET_INITRD=""
FADUMP_REGISTER_SYS_NODE="/sys/kernel/fadump_registered"
#kdump shall be the default dump mode
DEFAULT_DUMP_MODE="kdump"
image_time=0

. /lib/kdump/kdump-lib.sh

standard_kexec_args="-p"

# Some default values in case /etc/sysconfig/kdump doesn't include
KDUMP_COMMANDLINE_REMOVE="hugepages hugepagesz slub_debug"

if [ -f /etc/sysconfig/kdump ]; then
	. /etc/sysconfig/kdump
fi

single_instance_lock()
{
	local rc timeout=5

	exec 9>/var/lock/kdump

	if [ $? -ne 0 ]; then
		echo "Create file lock failed"
		exit 1
	fi

	flock -n 9
	rc=$?

	while [ $rc -ne 0 ]; do
		echo "Another app is currently holding the kdump lock; waiting for it to exit..."
		flock -w $timeout 9
		rc=$?
	done
}

determine_dump_mode()
{
	# Check if firmware-assisted dump is enabled
	# if yes, set the dump mode as fadump
	if is_fadump_capable; then
		echo "Dump mode is fadump"
		DEFAULT_DUMP_MODE="fadump"
	fi
}

# remove_cmdline_param <kernel cmdline> <param1> [<param2>] ... [<paramN>]
# Remove a list of kernel parameters from a given kernel cmdline and print the result.
# For each "arg" in the removing params list, "arg" and "arg=xxx" will be removed if exists.
remove_cmdline_param()
{
	local cmdline=$1
	shift

	for arg in $@; do
		cmdline=`echo $cmdline | \
			 sed -e "s/\b$arg=[^ ]*//g" \
			     -e "s/^$arg\b//g" \
			     -e "s/[[:space:]]$arg\b//g" \
			     -e "s/\s\+/ /g"`
	done
	echo $cmdline
}

#
# This function returns the "apicid" of the boot
# cpu (cpu 0) if present.
#
get_bootcpu_apicid()
{
    awk '							\
	BEGIN { CPU = "-1"; }					\
	$1=="processor" && $2==":"	{ CPU = $NF; }		\
	CPU=="0" && /^apicid/		{ print $NF; }		\
	'							\
	/proc/cpuinfo
}

#
# This function appends argument "$2=$3" to string ($1) if not already present.
#
append_cmdline()
{
	local cmdline=$1
	local newstr=${cmdline/$2/""}

	# unchanged str implies argument wasn't there
	if [ "$cmdline" == "$newstr" ]; then
		cmdline="${cmdline} ${2}=${3}"
	fi

	echo $cmdline
}

# This function performs a series of edits on the command line.
# Store the final result in global $KDUMP_COMMANDLINE.
prepare_cmdline()
{
	local cmdline id

	if [ -z "$KDUMP_COMMANDLINE" ]; then
		cmdline=$(cat /proc/cmdline)
	else
		cmdline=${KDUMP_COMMANDLINE}
	fi

	# These params should always be removed
	cmdline=$(remove_cmdline_param "$cmdline" crashkernel panic_on_warn)
	# These params can be removed configurably
	cmdline=$(remove_cmdline_param "$cmdline" ${KDUMP_COMMANDLINE_REMOVE})

	# Always remove "root=X", as we now explicitly generate all kinds
	# of dump target mount information including root fs.
	#
	# We do this before KDUMP_COMMANDLINE_APPEND, if one really cares
	# about it(e.g. for debug purpose), then can pass "root=X" using
	# KDUMP_COMMANDLINE_APPEND.
	cmdline=$(remove_cmdline_param "$cmdline" root)

	# With the help of "--hostonly-cmdline", we can avoid some interitage.
	cmdline=$(remove_cmdline_param "$cmdline" rd.lvm.lv rd.luks.uuid rd.dm.uuid rd.md.uuid fcoe)

	# Remove netroot, rd.iscsi.initiator and iscsi_initiator since
	# we get duplicate entries for the same in case iscsi code adds
	# it as well.
	cmdline=$(remove_cmdline_param "$cmdline" netroot rd.iscsi.initiator iscsi_initiator)

	cmdline="${cmdline} ${KDUMP_COMMANDLINE_APPEND}"

	id=$(get_bootcpu_apicid)
	if [ ! -z ${id} ] ; then
		cmdline=$(append_cmdline "${cmdline}" disable_cpu_apicid ${id})
	fi
	if has_hpwdt; then
		cmdline="${cmdline} rd.driver.pre=hpwdt"
	fi

	KDUMP_COMMANDLINE=$cmdline
}


save_core()
{
	coredir="/var/crash/`date +"%Y-%m-%d-%H:%M"`"

	mkdir -p $coredir
	cp --sparse=always /proc/vmcore $coredir/vmcore-incomplete
	if [ $? == 0 ]; then
		mv $coredir/vmcore-incomplete $coredir/vmcore
		echo "saved a vmcore to $coredir"
	else
		echo "failed to save a vmcore to $coredir" >&2
	fi

	# pass the dmesg to Abrt tool if exists, in order
	# to collect the kernel oops message.
	# https://fedorahosted.org/abrt/
	if [ -x /usr/bin/dumpoops ]; then
		makedumpfile --dump-dmesg $coredir/vmcore $coredir/dmesg >/dev/null 2>&1
		dumpoops -d $coredir/dmesg >/dev/null 2>&1
		if [ $? == 0 ]; then
			echo "kernel oops has been collected by abrt tool"
		fi
	fi
}

rebuild_fadump_initrd()
{
	local target_initrd_tmp

	# this file tells the initrd is fadump enabled
	touch /tmp/fadump.initramfs
	target_initrd_tmp="$TARGET_INITRD.tmp"
	$MKDUMPRD $target_initrd_tmp --rebuild $DEFAULT_INITRD_BAK --kver $kdump_kver \
		-i /tmp/fadump.initramfs /etc/fadump.initramfs
	if [ $? != 0 ]; then
		echo "mkdumprd: failed to rebuild initrd with fadump support" >&2
		rm -f /tmp/fadump.initramfs
		return 1
	fi
	rm -f /tmp/fadump.initramfs

	# updating fadump initrd
	mv $target_initrd_tmp $TARGET_INITRD
	sync

	return 0
}

rebuild_kdump_initrd()
{
	$MKDUMPRD $TARGET_INITRD $kdump_kver
	if [ $? != 0 ]; then
		echo "mkdumprd: failed to make kdump initrd" >&2
		return 1
	fi

	return 0
}

rebuild_initrd()
{
	if [[ ! -w "$KDUMP_BOOTDIR" ]];then
		echo "$KDUMP_BOOTDIR does not have write permission. Can not rebuild $TARGET_INITRD"
		return 1
	fi

	if [ $DEFAULT_DUMP_MODE == "fadump" ]; then
		rebuild_fadump_initrd
	else
		rebuild_kdump_initrd
	fi

	return $?
}

#$1: the files to be checked with IFS=' '
check_exist()
{
	for file in $1; do
		if [ ! -f "$file" ]; then
			echo -n "Error: $file not found."; echo
			return 1
		fi
	done
}

#$1: the files to be checked with IFS=' '
check_executable()
{
	for file in $1; do
		if [ ! -x "$file" ]; then
			echo -n "Error: $file is not executable."; echo
			return 1
		fi
	done
}

backup_default_initrd()
{
	if [ ! -f "$DEFAULT_INITRD" ]; then
		return
	fi

	if [ ! -e $DEFAULT_INITRD_BAK ]; then
		echo "Backing up $DEFAULT_INITRD before rebuild."
		# save checksum to verify before restoring
		sha1sum $DEFAULT_INITRD > $INITRD_CHECKSUM_LOCATION
		cp $DEFAULT_INITRD $DEFAULT_INITRD_BAK
		if [ $? -ne 0 ]; then
			echo "WARNING: failed to backup $DEFAULT_INITRD."
			rm -f $DEFAULT_INITRD_BAK
		fi
	fi
}

restore_default_initrd()
{
	# If a backup initrd exists, we must be switching back from
	# fadump to kdump. Restore the original default initrd.
	if [ -f $DEFAULT_INITRD_BAK ] && [ -f $INITRD_CHECKSUM_LOCATION ]; then
		# verify checksum before restoring
		backup_checksum=`sha1sum $DEFAULT_INITRD_BAK | awk '{ print $1 }'`
		default_checksum=`cat $INITRD_CHECKSUM_LOCATION | awk '{ print $1 }'`
		if [ "$default_checksum" != "$backup_checksum" ]; then
			echo "WARNING: checksum mismatch! Can't restore original initrd.."
		else
			rm -f $INITRD_CHECKSUM_LOCATION
			mv $DEFAULT_INITRD_BAK $DEFAULT_INITRD
			if [[ $? -eq 0 ]]; then
				echo -n "Restoring original initrd as fadump mode "
				echo "is disabled."
				sync
			fi
		fi
	fi
}

check_config()
{
	local nr

	nr=$(awk 'BEGIN{cnt=0} /^raw|^ssh[[:blank:]]|^nfs|^ext[234]|^xfs|^btrfs|^minix|^dracut_args .*\-\-mount/{cnt++} END{print cnt}' $KDUMP_CONFIG_FILE)
	[ $nr -gt 1 ] && {
		echo "More than one dump targets specified."
		return 1
	}

	nr=$(grep "^dracut_args .*\-\-mount" $KDUMP_CONFIG_FILE | grep -o "\-\-mount" | wc -l)
	[ $nr -gt 1 ] && {
		echo "Multiple mount targets specified in one \"dracut_args\"."
		return 1
	}

	# Check if we have any leading spaces (or tabs) before the
	# variable name in the kdump conf file
	if grep -E -q '^[[:blank:]]+[a-z]' $KDUMP_CONFIG_FILE; then
		echo "No whitespaces are allowed before a kdump option name in $KDUMP_CONFIG_FILE"
		return 1
	fi

	while read config_opt config_val; do
		case "$config_opt" in
		\#* | "")
			;;
		raw|ext2|ext3|ext4|minix|btrfs|xfs|nfs|ssh|sshkey|path|core_collector|kdump_post|kdump_pre|extra_bins|extra_modules|default|force_rebuild|force_no_rebuild|dracut_args|fence_kdump_args|fence_kdump_nodes)
			# remove inline comments after the end of a directive.
			[ -z "$config_val" ] && {
				echo "Invalid kdump config value for option $config_opt."
				return 1;
			}
			;;
		net|options|link_delay|disk_timeout|debug_mem_level|blacklist)
			echo "Deprecated kdump config option: $config_opt. Refer to kdump.conf manpage for alternatives."
			return 1
			;;
		*)
			echo "Invalid kdump config option $config_opt"
			return 1;
			;;
		esac
	done <<< "$(read_strip_comments $KDUMP_CONFIG_FILE)"

	check_default_config || return 1

	check_fence_kdump_config || return 1

	return 0
}

# get_pcs_cluster_modified_files <image timestamp>
# return list of modified file for fence_kdump modified in Pacemaker cluster
get_pcs_cluster_modified_files()
{
	local time_stamp
	local modified_files

	is_generic_fence_kdump && return 1
	is_pcs_fence_kdump || return 1

	time_stamp=`pcs cluster cib | xmllint --xpath 'string(/cib/@cib-last-written)' - | \
		xargs -0 date +%s --date`

	if [ -n $time_stamp -a $time_stamp -gt $image_time ]; then
		modified_files="cluster-cib"
	fi

	if [ -f $FENCE_KDUMP_CONFIG_FILE ]; then
		time_stamp=`stat -c "%Y" $FENCE_KDUMP_CONFIG_FILE`
		if [ "$time_stamp" -gt "$image_time" ]; then
			modified_files="$modified_files $FENCE_KDUMP_CONFIG_FILE"
		fi
	fi

	echo $modified_files
}

check_boot_dir()
{
	#If user specify a boot dir for kdump kernel, let's use it. Otherwise
	#check whether it's a atomic host. If yes parse the subdirectory under
	#/boot; If not just find it under /boot.
	[ -n "$KDUMP_BOOTDIR" ] && return

	if ! is_atomic || [ "$(uname -m)" = "s390x" ]; then
		KDUMP_BOOTDIR="/boot"
	else
		eval $(cat /proc/cmdline| grep "BOOT_IMAGE" | cut -d' ' -f1)
		KDUMP_BOOTDIR="/boot"$(dirname $BOOT_IMAGE)
	fi
}

setup_initrd()
{
	check_boot_dir

	if [ -z "$KDUMP_KERNELVER" ]; then
		kdump_kver=`uname -r`
	else
		kdump_kver=$KDUMP_KERNELVER
	fi

	kdump_kernel="${KDUMP_BOOTDIR}/${KDUMP_IMG}-${kdump_kver}${KDUMP_IMG_EXT}"

	DEFAULT_INITRD="${KDUMP_BOOTDIR}/initramfs-`uname -r`.img"
	DEFAULT_INITRD_BAK="${KDUMP_BOOTDIR}/.initramfs-`uname -r`.img.default"
	if [ $DEFAULT_DUMP_MODE == "fadump" ]; then
		TARGET_INITRD="$DEFAULT_INITRD"

		# backup initrd for reference before replacing it
		# with fadump aware initrd
		backup_default_initrd
	else
		TARGET_INITRD="${KDUMP_BOOTDIR}/initramfs-${kdump_kver}kdump.img"

		# check if a backup of default initrd exists. If yes,
		# it signifies a switch from fadump mode. So, restore
		# the backed up default initrd.
		restore_default_initrd
	fi
}

check_files_modified()
{
	local modified_files=""

	#also rebuild when Pacemaker cluster conf is changed and fence kdump is enabled.
	modified_files=$(get_pcs_cluster_modified_files)

	EXTRA_BINS=`grep ^kdump_post $KDUMP_CONFIG_FILE | cut -d\  -f2`
	CHECK_FILES=`grep ^kdump_pre $KDUMP_CONFIG_FILE | cut -d\  -f2`
	CORE_COLLECTOR=`grep ^core_collector $KDUMP_CONFIG_FILE | cut -d\  -f2`
	CORE_COLLECTOR=`type -P $CORE_COLLECTOR`
	EXTRA_BINS="$EXTRA_BINS $CHECK_FILES"
	CHECK_FILES=`grep ^extra_bins $KDUMP_CONFIG_FILE | cut -d\  -f2-`
	EXTRA_BINS="$EXTRA_BINS $CHECK_FILES"
	files="$KDUMP_CONFIG_FILE $kdump_kernel $EXTRA_BINS $CORE_COLLECTOR"
	[[ -e /etc/fstab ]] && files="$files /etc/fstab"

	check_exist "$files" && check_executable "$EXTRA_BINS"
	[ $? -ne 0 ] && return 2

	for file in $files; do
		time_stamp=`stat -c "%Y" $file`
		if [ "$time_stamp" -gt "$image_time" ]; then
			modified_files="$modified_files $file"
		fi
	done
	if [ -n "$modified_files" ]; then
		echo "Detected change(s) in the following file(s):"
		echo -n "  "; echo "$modified_files" | sed 's/\s/\n  /g'
		return 1
	fi

	return 0
}

check_dump_fs_modified()
{
	local _old_dev _old_mntpoint _old_fstype
	local _new_dev _new_mntpoint _new_fstype
	local _target _path _dracut_args
	local _target_drivers _module_name

	local _old_drivers="$(lsinitrd $TARGET_INITRD -f /usr/lib/dracut/loaded-kernel-modules.txt | tr '\n' ' ')"

	# No need to check in case of mount target specified via "dracut_args".
	if is_mount_in_dracut_args; then
		return 0
	fi

	# No need to check in case of raw target.
	# Currently we do not check also if ssh/nfs target is specified
	if is_ssh_dump_target || is_nfs_dump_target || is_raw_dump_target; then
		return 0
	fi

	_target=$(get_user_configured_dump_disk)

	if [[ -n "$_target" ]]; then
		_target=$(to_dev_name $_target)
		_new_fstype=$(blkid $_target | awk -F"TYPE=" '{print $2}' | cut -d '"' -f 2)
	else
		_path=$(get_save_path)
		set -- $(df -T $_path 2>/dev/null | tail -1 | awk '{ print $1, $2}')
		_target=$(to_dev_name $1)
		_new_fstype=$2
		if [[ -z "$_target" || -z "$_new_fstype" ]];then
			echo "Dump path $_path does not exist"
			return 2
		fi
	fi

	_record_block_drivers() {
		local _drivers
		if [[ -b /dev/block/$1 ]]; then
			_drivers=$(udevadm info -a "/dev/block/$1" | sed -n 's/\s*DRIVERS=="\(\S\+\)"/\1/p')
		fi
		if [[ -b $1 ]]; then
			_drivers=$(udevadm info -a "$1" | sed -n 's/\s*DRIVERS=="\(\S\+\)"/\1/p')
		fi
		for _driver in $_drivers; do
			if ! [[ " $_target_drivers " == *" $_driver "* ]]; then
				_target_drivers="$_target_drivers $_driver"
			fi
		done
		return 1
	}

	check_block_and_slaves_all _record_block_drivers "$(get_maj_min "$_target")"
	for _driver in $_target_drivers; do
		# Older version of kmod util doesn't give module name, so follow Kbuild's
		# name-fix rule and deduce the name.
		_module_name=$(echo "$_driver" | sed "s/\(,\|-\)/_/g")
		# Target is mounted already, if module is not included by current kernel,
		# could be a deprecated/invalid driver name or builtin module
		if ! (grep -q "\b$_module_name\b" /proc/modules); then
			continue
		fi
		if ! [[ " $_old_drivers " == *" $_module_name "* ]]; then
			echo "Detected change in block device driver, $_module_name is not included"
			return 1
		fi
	done

	if [[ $(expr substr $_new_fstype 1 3) = "nfs" ]];then
		_new_dev=$_target
	else
		_new_dev=$(kdump_get_persistent_dev $_target $_new_fstype)
	fi

	if ! findmnt $_target >/dev/null; then
		echo "Dump target $_target is probably not mounted."
		return 2
	fi

	if [[ "$_target" = "$(get_root_fs_device)" ]]; then
		_new_mntpoint="/sysroot"
	else
		_new_mntpoint="/kdumproot/$(get_mntpoint_from_target $_target)"
	fi

	_dracut_args=$(lsinitrd $TARGET_INITRD -f usr/lib/dracut/build-parameter.txt)
	if [[ -z "$_dracut_args" ]];then
		echo "Warning: No dracut arguments found in initrd"
		return 0
	fi

	# if --mount argument present then match old and new target, mount
	# point and file system. If any of them mismatches then rebuild
	echo $_dracut_args | grep "\-\-mount" &> /dev/null
	if [[ $? -eq 0 ]];then
		set -- $(echo $_dracut_args | awk -F "--mount '" '{print $2}' | cut -d' ' -f1,2,3)
		_old_dev=$1
		_old_mntpoint=$2
		_old_fstype=$3
		[[ $_new_dev = $_old_dev && $_new_mntpoint = $_old_mntpoint && $_new_fstype = $_old_fstype ]] && return 0
	# otherwise rebuild if target device is not a root device
	else
		[[ "$_target" = "$(get_root_fs_device)" ]] && return 0
	fi

	echo "Detected change in File System"
	return 1
}

check_wdt_modified()
{
	local -A _drivers
	local _alldrivers _active _wdtdrv _wdtppath _dir
	local wd_old wd_new

	is_wdt_mod_omitted
	[[ $? -eq 0 ]] && return 0
	[[ -d /sys/class/watchdog/ ]] || return 0

	# Copied logic from dracut 04watchdog/module-setup.sh::installkernel()
	for _dir in /sys/class/watchdog/*; do
		[[ -d "$_dir" ]] || continue
		[[ -f "$_dir/state" ]] || continue
		_active=$(< "$_dir/state")
		[[ "$_active" =  "active" ]] || continue
		# device/modalias will return driver of this device
		_wdtdrv=$(< "$_dir/device/modalias")
		# There can be more than one module represented by same
		# modalias. Currently load all of them.
		# TODO: Need to find a way to avoid any unwanted module
		# represented by modalias
		_wdtdrv=$(modprobe --set-version "$kdump_kver" -R $_wdtdrv 2>/dev/null)
		if [[ $_wdtdrv ]]; then
			for i in $_wdtdrv; do
				_drivers[$i]=1
			done
		fi
		# however in some cases, we also need to check that if there is
		# a specific driver for the parent bus/device.  In such cases
		# we also need to enable driver for parent bus/device.
		_wdtppath=$(readlink -f "$_dir/device")
		while [[ -d "$_wdtppath" ]] && [[ "$_wdtppath" != "/sys" ]]; do
			_wdtppath=$(readlink -f "$_wdtppath/..")
			[[ -f "$_wdtppath/modalias" ]] || continue

			_wdtdrv=$(< "$_wdtppath/modalias")
			_wdtdrv=$(modprobe --set-version "$kdump_kver" -R $_wdtdrv 2>/dev/null)
			if [[ $_wdtdrv ]]; then
				for i in $_wdtdrv; do
					_drivers[$i]=1
				done
			fi
		done
	done

	# ensure that watchdog module is loaded as early as possible
	_alldrivers="${!_drivers[*]}"
	[[ $_alldrivers ]] && wd_new="rd.driver.pre=${_alldrivers// /,}"
	wd_old=$(lsinitrd $TARGET_INITRD -f etc/cmdline.d/00-watchdog.conf)

	[[ "$wd_old" = "$wd_new" ]] && return 0

	return 1
}

# returns 0 if system is not modified
# returns 1 if system is modified
# returns 2 if system modification is invalid
check_system_modified()
{
	local ret

	[[ -f $TARGET_INITRD ]] || return 1

	check_files_modified
	ret=$?
	if [ $ret -ne 0 ]; then
		return $ret
	fi

	check_dump_fs_modified
	ret=$?
	if [ $ret -ne 0 ]; then
		return $ret
	fi

	check_wdt_modified
	if [ $? -ne 0 ]; then
		echo "Detected change in watchdog state"
		return 1
	fi

	return 0
}

check_rebuild()
{
	local extra_modules
	local capture_capable_initrd="1"
	local _force_rebuild force_rebuild="0"
	local _force_no_rebuild force_no_rebuild="0"
	local ret system_modified="0"

	setup_initrd
	if [ $? -ne 0 ]; then
		return 1
	fi

	_force_no_rebuild=`grep ^force_no_rebuild $KDUMP_CONFIG_FILE 2>/dev/null`
	if [ $? -eq 0 ]; then
		force_no_rebuild=`echo $_force_no_rebuild | cut -d' '  -f2`
		if [ "$force_no_rebuild" != "0" ] && [ "$force_no_rebuild" != "1" ];then
			echo "Error: force_no_rebuild value is invalid"
			return 1
		fi
	fi

	_force_rebuild=`grep ^force_rebuild $KDUMP_CONFIG_FILE 2>/dev/null`
	if [ $? -eq 0 ]; then
		force_rebuild=`echo $_force_rebuild | cut -d' '  -f2`
		if [ "$force_rebuild" != "0" ] && [ "$force_rebuild" != "1" ];then
			echo "Error: force_rebuild value is invalid"
			return 1
		fi
	fi

	if [[ "$force_no_rebuild" == "1" && "$force_rebuild" == "1" ]]; then
		echo "Error: force_rebuild and force_no_rebuild are enabled simultaneously in kdump.conf"
		return 1
	fi

	# Will not rebuild kdump initrd
	if [ "$force_no_rebuild" == "1" ]; then
		return 0
	fi

	#will rebuild every time if extra_modules are specified
	extra_modules=`grep ^extra_modules $KDUMP_CONFIG_FILE`
	[ -n "$extra_modules" ] && force_rebuild="1"

	#check to see if dependent files has been modified
	#since last build of the image file
	if [ -f $TARGET_INITRD ]; then
		image_time=`stat -c "%Y" $TARGET_INITRD 2>/dev/null`

		#in case of fadump mode, check whether the default/target
		#initrd is already built with dump capture capability
		if [ "$DEFAULT_DUMP_MODE" == "fadump" ]; then
			capture_capable_initrd=$(lsinitrd -f $DRACUT_MODULES_FILE $TARGET_INITRD | grep ^kdumpbase$ | wc -l)
		fi
	fi

	check_system_modified
	ret=$?
	if [ $ret -eq 2 ]; then
		return 1
	elif [ $ret -eq 1 ];then
		system_modified="1"
	fi

	if [ $image_time -eq 0 ]; then
		echo  -n "No kdump initial ramdisk found."; echo
	elif [ "$capture_capable_initrd" == "0" ]; then
		echo -n "Rebuild $TARGET_INITRD with dump capture support"; echo
	elif [ "$force_rebuild" != "0" ]; then
		echo -n "Force rebuild $TARGET_INITRD"; echo
	elif [ "$system_modified" != "0" ]; then
		:
	else
		return 0
	fi

	echo "Rebuilding $TARGET_INITRD"
	rebuild_initrd
	return $?
}

# This function check iomem and determines if we have more than
# 4GB of ram available. Returns 1 if we do, 0 if we dont
need_64bit_headers()
{
	return `tail -n 1 /proc/iomem | awk '{ split ($1, r, "-"); \
	print (strtonum("0x" r[2]) > strtonum("0xffffffff")); }'`
}

# Load the kdump kernel specified in /etc/sysconfig/kdump
# If none is specified, try to load a kdump kernel with the same version
# as the currently running kernel.
load_kdump()
{
	ARCH=`uname -m`
	if [ "$ARCH" == "i686" -o "$ARCH" == "i386" ]
	then

		need_64bit_headers
		if [ $? == 1 ]
		then
			FOUND_ELF_ARGS=`echo $KEXEC_ARGS | grep elf32-core-headers`
			if [ -n "$FOUND_ELF_ARGS" ]
			then
				echo -n "Warning: elf32-core-headers overrides correct elf64 setting"
				echo
			else	
				KEXEC_ARGS="$KEXEC_ARGS --elf64-core-headers"
			fi
		else
			FOUND_ELF_ARGS=`echo $KEXEC_ARGS | grep elf64-core-headers`
			if [ -z "$FOUND_ELF_ARGS" ]
			then
				KEXEC_ARGS="$KEXEC_ARGS --elf32-core-headers"
			fi
		fi
	fi

	prepare_cmdline

	# For secureboot enabled machines, use new kexec file based syscall.
	# Old syscall will always fail as it does not have capability to
	# to kernel signature verification.
	if is_secure_boot_enforced; then
		echo "Secure Boot is enabled. Using kexec file based syscall."
		KEXEC_ARGS="$KEXEC_ARGS -s"
	elif is_secure_mode_enforced; then
		echo "securelevel is set to 1 (Secure Mode). Using kexec file based syscall."
		KEXEC_ARGS="$KEXEC_ARGS -s"
	fi

	$KEXEC $KEXEC_ARGS $standard_kexec_args \
		--command-line="$KDUMP_COMMANDLINE" \
		--initrd=$TARGET_INITRD $kdump_kernel
	if [ $? == 0 ]; then
		echo "kexec: loaded kdump kernel"
		return 0
	else
		echo "kexec: failed to load kdump kernel" >&2
		return 1
	fi
}

check_ssh_config()
{
	while read config_opt config_val; do
		case "$config_opt" in
		sshkey)
			# remove inline comments after the end of a directive.
			if [ -f "$config_val" ]; then
				# canonicalize the path
				SSH_KEY_LOCATION=$(/usr/bin/readlink -m $config_val)
			else
				echo "WARNING: '$config_val' doesn't exist, using default value '$SSH_KEY_LOCATION'"
			fi
			;;
		path)
			SAVE_PATH=$config_val
			;;
		ssh)
			DUMP_TARGET=$config_val
			;;
		*)
			;;
		esac
	done <<< "$(read_strip_comments $KDUMP_CONFIG_FILE)"

	#make sure they've configured kdump.conf for ssh dumps
	local SSH_TARGET=`echo -n $DUMP_TARGET | sed -n '/.*@/p'`
	if [ -z "$SSH_TARGET" ]; then
		return 1
	fi
	return 0
}

# ipv6 host address may takes a long time to be ready.
# Instead of checking against ipv6 address, we just check the network reachable
# by the return val of 'ssh'
check_and_wait_network_ready()
{
	local start_time=$(date +%s)
	local warn_once=1
	local cur
	local diff
	local retval
	local errmsg

	while true; do
		errmsg=$(ssh -i $SSH_KEY_LOCATION -o BatchMode=yes $DUMP_TARGET mkdir -p $SAVE_PATH 2>&1)
		retval=$?

		# ssh exits with the exit status of the remote command or with 255 if an error occurred
		if [ $retval -eq 0 ]; then
			return 0
		elif [ $retval -ne 255 ]; then
			echo "Could not create $DUMP_TARGET:$SAVE_PATH, you should check the privilege on server side"  >&2
			return 1
		fi

		# if server removes the authorized_keys or, no /root/.ssh/kdump_id_rsa
		echo $errmsg | grep -q "Permission denied\|No such file or directory\|Host key verification failed"
		if [ $? -eq 0 ]; then
			echo "Could not create $DUMP_TARGET:$SAVE_PATH, you probably need to run \"kdumpctl propagate\""  >&2
			return 1
		fi

		if [ $warn_once -eq 1 ]; then
			echo "Network dump target is not usable, waiting for it to be ready"
			warn_once=0
		fi
		echo -n .

		cur=$(date +%s)
		let "diff = $cur - $start_time"
		# 60s time out
		if [ $diff -gt 180 ]; then
			break;
		fi
		sleep 1
	done

	echo "Could not create $DUMP_TARGET:$SAVE_PATH, ipaddr is not ready yet. You should check network connection"  >&2
	return 1
}

check_ssh_target()
{
	check_and_wait_network_ready
	if [ $? -ne 0 ]; then
		return 1
	fi
	return 0
}

propagate_ssh_key()
{
	check_ssh_config
	if [ $? -ne 0 ]; then
		echo "No ssh config specified in $KDUMP_CONFIG_FILE.  Can't propagate" >&2
		exit 1
	fi

	local KEYFILE=$SSH_KEY_LOCATION
	local errmsg="Failed to propagate ssh key"

	#Check to see if we already created key, if not, create it.
	if [ -f $KEYFILE ]; then
		echo "Using existing keys..."
	else
		echo -n "Generating new ssh keys... "
		/usr/bin/ssh-keygen -t rsa -f $KEYFILE -N "" 2>&1 > /dev/null
		echo "done."
	fi

	#now find the target ssh user and server to contact.
	SSH_USER=`echo $DUMP_TARGET | cut -d\  -f2 | cut -d@ -f1`
	SSH_SERVER=`echo $DUMP_TARGET | sed -e's/\(.*@\)\(.*$\)/\2/'`

	#now send the found key to the found server
	ssh-copy-id -i $KEYFILE $SSH_USER@$SSH_SERVER
	RET=$?
	if [ $RET == 0 ]; then
		echo $KEYFILE has been added to ~$SSH_USER/.ssh/authorized_keys on $SSH_SERVER
		return 0
	else
		echo $errmsg, $KEYFILE failed in transfer to $SSH_SERVER  >&2
		exit 1
	fi
}

show_reserved_mem()
{
    local mem=$(cat /sys/kernel/kexec_crash_size)
    local mem_mb=$(expr $mem / 1024 / 1024)

    echo "Reserved "$mem_mb"MB memory for crash kernel"
}

check_current_fadump_status()
{
	# Check if firmware-assisted dump has been registered.
	rc=`cat $FADUMP_REGISTER_SYS_NODE`
	[ $rc -eq 1 ] && return 0
	return 1
}

check_current_kdump_status()
{
	rc=`cat /sys/kernel/kexec_crash_loaded`
	if [ $rc == 1 ]; then
		return 0
	else
		return 1
	fi
}

check_current_status()
{
	if [ $DEFAULT_DUMP_MODE == "fadump" ]; then
		check_current_fadump_status
	else
		check_current_kdump_status
	fi

	return $?
}

save_raw()
{
	local kdump_dir
	local raw_target

	raw_target=$(awk '$1 ~ /^raw$/ { print $2; }' $KDUMP_CONFIG_FILE)
	[ -z "$raw_target" ] && return 0
	[ -b "$raw_target" ] || {
		echo "raw partition $raw_target not found"
		return 1
	}
	kdump_dir=`grep ^path $KDUMP_CONFIG_FILE | cut -d' '  -f2-`
	if [ -z "${kdump_dir}" ]; then
		coredir="/var/crash/`date +"%Y-%m-%d-%H:%M"`"
	else
		coredir="${kdump_dir}/`date +"%Y-%m-%d-%H:%M"`"
	fi

	mkdir -p "$coredir"
	[ -d "$coredir" ] || {
		echo "failed to create $coredir"
		return 1
	}
	if makedumpfile -R $coredir/vmcore <$raw_target >/dev/null 2>&1; then
		# dump found
		echo "Dump saved to $coredir/vmcore"
		# wipe makedumpfile header
		dd if=/dev/zero of=$raw_target bs=1b count=1 2>/dev/null
	else
		rm -rf "$coredir"
	fi

	return 0
}

is_dump_target_configured()
{
	local _target

	_target=$(egrep "^ext[234]|^xfs|^btrfs|^minix|^raw|^ssh|^nfs" /etc/kdump.conf)

	[ -n "$_target" ]
}

local_fs_dump_target()
{
	local _target

	_target=$(egrep "^ext[234]|^xfs|^btrfs|^minix" /etc/kdump.conf)
	if [ $? -eq 0 ]; then
		echo $_target|awk '{print $2}'
	fi
}

path_to_be_relabeled()
{
	local _path _target _mnt="/" _rmnt

	if is_dump_target_configured; then
		_target=$(local_fs_dump_target)
		if [[ -n "$_target" ]]; then
			_mnt=$(findmnt -k -f -n -r -o TARGET $_target)
			if [ -z "$_mnt" ]; then
				return
			fi
		else
			return
		fi
	fi

	if is_mount_in_dracut_args; then
		return;
	fi
	_path=$(get_save_path)
	# if $_path is masked by other mount, we will not relabel it.
	_rmnt=$(df $_mnt/$_path 2>/dev/null | tail -1 | awk '{ print $NF }')
	if [ "$_rmnt" == "$_mnt" ]; then
		echo $_mnt/$_path
	fi
}

selinux_relabel()
{
	local _path _i _attr

	_path=$(path_to_be_relabeled)
	if [ -z "$_path" ] || ! [ -d "$_path" ] ; then
		return
	fi

	for _i in $(find $_path); do
		_attr=$(getfattr -m "security.selinux" $_i 2>/dev/null)
		if [ -z "$_attr" ]; then
			restorecon $_i;
		fi
	done
}

# Check if secure boot is being enforced.
#
# Per Peter Jones, we need check efivar SecureBoot-$(the UUID) and
# SetupMode-$(the UUID), they are both 5 bytes binary data. The first four
# bytes are the attributes associated with the variable and can safely be
# ignored, the last bytes are one-byte true-or-false variables. If SecureBoot
# is 1 and SetupMode is 0, then secure boot is being enforced.
#
# SecureBoot-UUID won't always be set when securelevel is 1. For legacy-mode
# and uefi-without-seucre-enabled system, we can manually enable secure mode
# by writing "1" to securelevel. So check both efi var and secure mode is a 
# more sane way.
#
# Assume efivars is mounted at /sys/firmware/efi/efivars.
is_secure_boot_enforced()
{
	local secure_boot_file setup_mode_file
	local secure_boot_byte setup_mode_byte

	secure_boot_file=$(find /sys/firmware/efi/efivars -name SecureBoot-* 2>/dev/null)
	setup_mode_file=$(find /sys/firmware/efi/efivars -name SetupMode-* 2>/dev/null)

	if [ -f "$secure_boot_file" ] && [ -f "$setup_mode_file" ]; then
		secure_boot_byte=$(hexdump -v -e '/1 "%d\ "' $secure_boot_file|cut -d' ' -f 5)
		setup_mode_byte=$(hexdump -v -e '/1 "%d\ "' $setup_mode_file|cut -d' ' -f 5)

		if [ "$secure_boot_byte" = "1" ] && [ "$setup_mode_byte" = "0" ]; then
			return 0
		fi
	fi

	return 1
}

# Check if secure mode is being enforced (securelevel =? 1)
is_secure_mode_enforced()
{
	local secure_mode_byte

	if [ ! -f /sys/kernel/security/securelevel ]; then
		return 1
	fi

	secure_mode_byte=$(cat /sys/kernel/security/securelevel)
	if [ "$secure_mode_byte" = "1" ]; then
		return 0
	fi

	return 1
}

check_crash_mem_reserved()
{
	local mem_reserved

	mem_reserved=$(cat /sys/kernel/kexec_crash_size)
	if [ $mem_reserved -eq 0 ]; then
		echo "No memory reserved for crash kernel"
		return 1
	fi

	return 0
}

check_kdump_feasibility()
{
	if [ ! -e /sys/kernel/kexec_crash_loaded ]; then
		echo "Kdump is not supported on this kernel"
		return 1
	fi
	check_crash_mem_reserved
	return $?
}

check_fence_kdump_config()
{
	local hostname=`hostname`
	local ipaddrs=`hostname -I`
	local nodes=$(get_option_value "fence_kdump_nodes")

	for node in $nodes; do
		if [ "$node" = "$hostname" ]; then
			echo "Option fence_kdump_nodes cannot contain $hostname"
			return 1
		fi
		# node can be ipaddr
		echo "$ipaddrs " | grep "$node " > /dev/null
		if [ $? -eq 0 ]; then
			echo "Option fence_kdump_nodes cannot contain $node"
			return 1
		fi
	done

	return 0
}

check_dump_feasibility()
{
	if [ $DEFAULT_DUMP_MODE == "fadump" ]; then
		return 0
	fi

	check_kdump_feasibility
	return $?
}

start_fadump()
{
	echo 1 > $FADUMP_REGISTER_SYS_NODE
	if ! check_current_fadump_status; then
		echo "fadump: failed to register"
		return 1
	fi

	echo "fadump: registered successfully"
	return 0
}

start_dump()
{
	if [ $DEFAULT_DUMP_MODE == "fadump" ]; then
		start_fadump
	else
		load_kdump
	fi

	return $?
}

check_default_config()
{
	local default_option

	default_option=$(awk '$1 ~ /^default$/ {print $2;}' $KDUMP_CONFIG_FILE)
	if [ -z "$default_option" ]; then
		return 0
	else
		case "$default_option" in
		  reboot|halt|poweroff|shell|dump_to_rootfs)
			return 0
		  ;;
		  *)
			echo $"Usage kdump.conf: default {reboot|halt|poweroff|shell|dump_to_rootfs}"
			return 1
		esac
	fi
}

start()
{
	check_dump_feasibility
	if [ $? -ne 0 ]; then
		echo "Starting kdump: [FAILED]"
		return 1
	fi

	check_config
	if [ $? -ne 0 ]; then
		echo "Starting kdump: [FAILED]"
		return 1
	fi

	if sestatus 2>/dev/null | grep -q "SELinux status.*enabled"; then
		selinux_relabel
	fi

	save_raw
	if [ $? -ne 0 ]; then
		echo "Starting kdump: [FAILED]"
		return 1
	fi

	check_current_status
	if [ $? == 0 ]; then
		echo "Kdump already running: [WARNING]"
		return 0
	fi

	if check_ssh_config; then
		if ! check_ssh_target; then
			echo "Starting kdump: [FAILED]"
			return 1
		fi
	fi

	check_rebuild
	if [ $? != 0 ]; then
		echo "Starting kdump: [FAILED]"
		return 1
	fi

	start_dump
	if [ $? != 0 ]; then
		echo "Starting kdump: [FAILED]"
		return 1
	fi

	echo "Starting kdump: [OK]"
}

reload()
{
	check_current_status
	if [ $? -ne 0 ]; then
		echo "Kdump is not running: [WARNING]"
		return 0
	fi

	if [ $DEFAULT_DUMP_MODE == "fadump" ]; then
		reload_fadump
		return $?
	else
		stop_kdump
	fi

	if [ $? -ne 0 ]; then
		echo "Stopping kdump: [FAILED]"
		return 1
	fi

	echo "Stopping kdump: [OK]"

	setup_initrd
	if [ $? -ne 0 ]; then
		echo "Starting kdump: [FAILED]"
		return 1
	fi

	start_dump
	if [ $? -ne 0 ]; then
		echo "Starting kdump: [FAILED]"
		return 1
	fi

	echo "Starting kdump: [OK]"
}

stop_fadump()
{
	echo 0 > $FADUMP_REGISTER_SYS_NODE
	if check_current_fadump_status; then
		echo "fadump: failed to unregister"
		return 1
	fi

	echo "fadump: unregistered successfully"
	return 0
}

stop_kdump()
{
	if is_secure_boot_enforced; then
		$KEXEC -s -p -u
	else
		$KEXEC -p -u
	fi

	if [ $? != 0 ]; then
		echo "kexec: failed to unload kdump kernel"
		return 1
	fi

	echo "kexec: unloaded kdump kernel"
	return 0
}

reload_fadump()
{
	echo 1 > $FADUMP_REGISTER_SYS_NODE
	if [ $? == 0 ]; then
		echo "fadump: re-registered successfully"
		return 0
	else
		# FADump could fail on older kernel where re-register
		# support is not enabled. Try stop/start from userspace
		# to handle such scenario.
		stop_fadump
		if [ $? == 0 ]; then
			start_fadump
			return $?
		fi
	fi

	return 1
}

stop()
{
	if [ $DEFAULT_DUMP_MODE == "fadump" ]; then
		stop_fadump
	else
		stop_kdump
	fi

	if [ $? != 0 ]; then
		echo "Stopping kdump: [FAILED]"
		return 1
	fi

	echo "Stopping kdump: [OK]"
	return 0
}

rebuild() {
	check_config
	if [ $? -ne 0 ]; then
		return 1
	fi

	if check_ssh_config; then
		if ! check_ssh_target; then
			return 1
		fi
	fi

	setup_initrd
	if [ $? -ne 0 ]; then
		return 1
	fi

	echo "Rebuilding $TARGET_INITRD"
	rebuild_initrd
	return $?
}

if [ ! -f "$KDUMP_CONFIG_FILE" ]; then
	echo "Error: No kdump config file found!"  >&2
	exit 1
fi

main ()
{
	# Determine if the dump mode is kdump or fadump
	determine_dump_mode

	case "$1" in
	  start)
		if [ -s /proc/vmcore ]; then
			save_core
			reboot
		else
			start
		fi
		;;
	  stop)
		stop
		;;
	  status)
		EXIT_CODE=0
		check_current_status
		case "$?" in
		  0)
			echo "Kdump is operational"
			EXIT_CODE=0
			;;
		  1)
			echo "Kdump is not operational"
			EXIT_CODE=3
			;;
		esac
		exit $EXIT_CODE
		;;
	  reload)
		reload
		;;
	  restart)
		stop
		start
		;;
	  rebuild)
		rebuild
		;;
	  condrestart)
		;;
	  propagate)
		propagate_ssh_key
		;;
	  showmem)
		show_reserved_mem
		;;
	  *)
		echo $"Usage: $0 {start|stop|status|restart|reload|rebuild|propagate|showmem}"
		exit 1
	esac
}

# Other kdumpctl instances will block in queue, until this one exits
single_instance_lock

# To avoid fd 9 leaking, we invoke a subshell, close fd 9 and call main.
# So that fd isn't leaking when main is invoking a subshell.
(exec 9<&-; main $1)

exit $?

Filemanager

Name Type Size Permission Actions
.aclocal-1.13.40009 File 35.87 KB 0755
.automake-1.13.40009 File 246.44 KB 0755
.g++.40009 File 754.59 KB 0755
.git-receive-pack.40009 File 1.46 MB 0755
.git-upload-archive.40009 File 1.46 MB 0755
.isc-config.sh.40009 File 3.4 KB 0755
.perl5.16.3.40009 File 11.14 KB 0755
.perlthanks.40009 File 43.61 KB 0755
.pstruct.40009 File 35.75 KB 0755
.s2p.40009 File 52.08 KB 0755
.x86_64-redhat-linux-c++.40009 File 754.59 KB 0755
.x86_64-redhat-linux-g++.40009 File 754.59 KB 0755
.x86_64-redhat-linux-gcc.40009 File 750.59 KB 0755
.zipinfo.40009 File 181.16 KB 0755
2to3 File 95 B 0755
GET File 14.71 KB 0755
HEAD File 14.71 KB 0755
Mail File 383.67 KB 0755
POST File 14.71 KB 0755
[ File 40.52 KB 0755
a2p File 105.32 KB 0755
ab File 157.59 KB 0755
aclocal File 35.87 KB 0755
aclocal-1.13 File 35.87 KB 0755
addr2line File 28.42 KB 0755
agentxtrap File 19.16 KB 0755
alias File 29 B 0755
alt-mysql-reconfigure File 21.15 KB 0755
alt-php-mysql-reconfigure File 21.15 KB 0755
alt-php-mysql-reconfigure.py File 21.15 KB 0755
animate File 7.05 KB 0755
annotate File 11.13 KB 0755
apropos File 45.49 KB 0755
ar File 61.21 KB 0755
arch File 32.3 KB 0755
arpaname File 7.03 KB 0755
as File 377.28 KB 0755
aserver File 28.21 KB 0755
aspell File 163.35 KB 0755
at File 51.73 KB 4755
atq File 51.73 KB 4755
atrm File 51.73 KB 4755
audit2allow File 14.21 KB 0755
audit2why File 14.21 KB 0755
aulast File 15.48 KB 0755
aulastlog File 11.35 KB 0755
ausyscall File 11.18 KB 0755
autoconf File 14.42 KB 0755
autoexpect File 7.53 KB 0755
autoheader File 8.33 KB 0755
autom4te File 31.43 KB 0755
automake File 246.44 KB 0755
automake-1.13 File 246.44 KB 0755
autopoint File 25.95 KB 0755
autoreconf File 20.57 KB 0755
autoscan File 16.72 KB 0755
autoupdate File 33.08 KB 0755
auvirt File 31.93 KB 0755
awk File 418.55 KB 0755
base64 File 36.48 KB 0755
basename File 28.35 KB 0755
bash File 941.93 KB 0755
bashbug File 6.8 KB 0755
bashbug-64 File 6.8 KB 0755
batch File 137 B 0755
bc File 81.47 KB 0755
bdftogd File 3.91 KB 0755
bdftopcf File 44.19 KB 0755
bdftruncate File 11.2 KB 0755
berkeley_db47_svc File 58.46 KB 0755
bg File 26 B 0755
bind9-config File 3.47 KB 0755
bison File 393.34 KB 0755
bond2team File 22.74 KB 0755
bootctl File 68.99 KB 0755
bunzip2 File 31.89 KB 0755
busctl File 403.15 KB 0755
bzcat File 31.89 KB 0755
bzcmp File 2.08 KB 0755
bzdiff File 2.08 KB 0755
bzgrep File 1.64 KB 0755
bzip2 File 31.89 KB 0755
bzip2recover File 15.24 KB 0755
bzless File 1.23 KB 0755
bzmore File 1.23 KB 0755
c++ File 754.59 KB 0755
c++filt File 27.92 KB 0755
c2ph File 35.75 KB 0755
c89 File 224 B 0755
c99 File 215 B 0755
ca-legacy File 1.6 KB 0755
cairo-sphinx File 69.99 KB 0755
cal File 36.8 KB 0755
captoinfo File 64.26 KB 0755
cat File 52.81 KB 0755
catchsegv File 3.26 KB 0755
catman File 36.75 KB 0755
cc File 750.59 KB 0755
cd File 26 B 0755
centrino-decode File 6.13 KB 0755
certutil File 179.75 KB 0755
chacl File 15.27 KB 0755
chage File 72.16 KB 4755
chardetect File 307 B 0755
chattr File 11.27 KB 0755
chcat File 13.12 KB 0755
chcon File 61.46 KB 0755
checkmodule File 400.48 KB 0755
checkpolicy File 412.46 KB 0755
chfn File 23.41 KB 4711
chgrp File 61.32 KB 0755
chmem File 40.43 KB 0755
chmod File 57.21 KB 0755
chown File 61.36 KB 0755
chronyc File 85.03 KB 0755
chrt File 32.17 KB 0755
chsh File 23.32 KB 0711
chvt File 11.14 KB 0755
ci File 801 B 0755
cifsiostat File 48.52 KB 0755
cksum File 32.38 KB 0755
cl-linksafe-reconfigure File 5.15 KB 0755
clear File 7.02 KB 0755
cmp File 44.14 KB 0755
cmsutil File 110.59 KB 0755
co File 801 B 0755
col File 23.88 KB 0755
colcrt File 11.29 KB 0755
colrm File 23.77 KB 0755
column File 27.99 KB 0755
comm File 36.55 KB 0755
command File 31 B 0755
compare File 11.09 KB 0755
compile_et File 1.45 KB 0755
composite File 7.05 KB 0755
config_data File 7.05 KB 0755
conjure File 7.05 KB 0755
convert File 7.05 KB 0755
coredumpctl File 154.52 KB 0755
corelist File 10.02 KB 0755
cp File 151.55 KB 0755
cpan File 4.97 KB 0755
cpan-mirrors File 4.27 KB 0555
cpan2dist File 21.31 KB 0755
cpanp File 3.31 KB 0755
cpanp-run-perl File 553 B 0755
cpapi1 File 3.02 MB 0755
cpapi2 File 3.02 MB 0755
cpapi3 File 3.02 MB 0755
cpio File 142.58 KB 0755
cpp File 754.58 KB 0755
cpupower File 66.34 KB 0755
crlutil File 127 KB 0755
crontab File 56.23 KB 4755
csplit File 48.82 KB 0755
csslint-0.6 File 19.55 KB 0755
curl File 153 KB 0755
cut File 40.61 KB 0755
cvtsudoers File 241.7 KB 0755
cxpm File 28.05 KB 0755
date File 60.74 KB 0755
db47_archive File 10.21 KB 0755
db47_checkpoint File 10.27 KB 0755
db47_codegen File 22.25 KB 0755
db47_deadlock File 10.28 KB 0755
db47_dump File 14.25 KB 0755
db47_hotbackup File 18.38 KB 0755
db47_load File 26.33 KB 0755
db47_printlog File 62.8 KB 0755
db47_recover File 10.27 KB 0755
db47_stat File 14.22 KB 0755
db47_upgrade File 10.23 KB 0755
db47_verify File 10.22 KB 0755
db_archive File 11.23 KB 0755
db_checkpoint File 11.3 KB 0755
db_deadlock File 11.31 KB 0755
db_dump File 15.33 KB 0755
db_dump185 File 64.45 KB 0755
db_hotbackup File 15.34 KB 0755
db_load File 27.51 KB 0755
db_log_verify File 15.34 KB 0755
db_printlog File 32.26 KB 0755
db_recover File 11.33 KB 0755
db_replicate File 15.34 KB 0755
db_stat File 15.26 KB 0755
db_tuner File 19.33 KB 0755
db_upgrade File 11.23 KB 0755
db_verify File 11.25 KB 0755
dbilogstrip File 1.43 KB 0755
dbiprof File 6.15 KB 0755
dbiproxy File 5.35 KB 0755
dbus-binding-tool File 94.49 KB 0755
dbus-cleanup-sockets File 11 KB 0755
dbus-daemon File 218 KB 0755
dbus-monitor File 23.13 KB 0755
dbus-run-session File 14.97 KB 0755
dbus-send File 27.07 KB 0755
dbus-test-tool File 23.13 KB 0755
dbus-update-activation-environment File 15.02 KB 0755
dbus-uuidgen File 10.98 KB 0755
dc File 44.33 KB 0755
dd File 73.14 KB 0755
deallocvt File 11.16 KB 0755
debuginfo-install File 7.88 KB 0755
delv File 39.98 KB 0755
df File 102.55 KB 0755
dgawk File 502.12 KB 0755
diff File 195.46 KB 0755
diff3 File 60.65 KB 0755
dig File 146.96 KB 0755
dir File 114.85 KB 0755
dircolors File 40.44 KB 0755
dirname File 28.31 KB 0755
dislocate File 7.75 KB 0755
display File 7.05 KB 0755
dltest File 11.05 KB 0755
dmesg File 48.52 KB 0755
dnsdomainname File 15.41 KB 0755
domainname File 15.41 KB 0755
doveadm File 2.94 MB 0755
doveconf File 541.95 KB 0755
dovecot-sysreport File 5.81 KB 0755
dpkg File 275.27 KB 0755
dpkg-deb File 140.41 KB 0755
dpkg-divert File 132.63 KB 0755
dpkg-maintscript-helper File 18.58 KB 0755
dpkg-query File 140.8 KB 0755
dpkg-split File 111.28 KB 0755
dpkg-statoverride File 70.52 KB 0755
dpkg-trigger File 66.26 KB 0755
dracut File 55.83 KB 0755
dsync File 2.94 MB 0755
dtrace File 16.66 KB 0755
du File 110.34 KB 0755
dumpkeys File 77.51 KB 0755
dumpsexp File 15.19 KB 0755
dvipdf File 1 KB 0755
dwp File 3.03 MB 0755
dwz File 162.6 KB 0755
ea-php56 File 4 MB 0755
ea-php56-pear File 383 B 0755
ea-php56-pecl File 299 B 0755
ea-php70 File 3.85 MB 0755
ea-php70-pear File 383 B 0755
ea-php70-pecl File 299 B 0755
ea-php73 File 4.65 MB 0755
ea-php73-pear File 383 B 0755
ea-php73-pecl File 299 B 0755
ea-php74 File 6.09 MB 0755
ea-php74-pear File 383 B 0755
ea-php74-pecl File 299 B 0755
ea-php80 File 6.67 MB 0755
ea-php80-pear File 383 B 0755
ea-php80-pecl File 299 B 0755
ea-php81 File 6.71 MB 0755
ea-php81-pear File 383 B 0755
ea-php81-pecl File 299 B 0755
easy_install File 320 B 0755
easy_install-2.7 File 328 B 0755
echo File 32.31 KB 0755
egrep File 290 B 0755
eject File 48.81 KB 0755
elfedit File 32.18 KB 0755
elinks File 1.3 MB 0755
enchant File 15.29 KB 0755
enchant-lsmod File 11.13 KB 0755
env File 28.33 KB 0755
envsubst File 36.01 KB 0755
eps2eps File 639 B 0755
eqn File 144.41 KB 0755
ex File 906.4 KB 0755
expand File 32.48 KB 0755
expect File 11.09 KB 0755
expr File 36.53 KB 0755
factor File 93.29 KB 0755
fallocate File 27.84 KB 0755
false File 28.25 KB 0755
fc File 26 B 0755
fc-cache File 132 B 0755
fc-cache-64 File 15.45 KB 0755
fc-cat File 15.4 KB 0755
fc-conflist File 11.2 KB 0755
fc-list File 11.26 KB 0755
fc-match File 11.32 KB 0755
fc-pattern File 11.26 KB 0755
fc-query File 11.23 KB 0755
fc-scan File 11.27 KB 0755
fc-validate File 11.27 KB 0755
fg File 26 B 0755
fgconsole File 11.16 KB 0755
fgrep File 290 B 0755
filan File 89.13 KB 0755
file File 19.3 KB 0755
find File 194.63 KB 0755
find-repos-of-install File 4.27 KB 0755
find2perl File 23.06 KB 0755
findmnt File 58.38 KB 0755
fipscheck File 15.37 KB 0755
fipshmac File 11.3 KB 0755
firewall-cmd File 113.48 KB 0755
firewall-offline-cmd File 101.18 KB 0755
flex File 318.07 KB 0755
flex++ File 318.07 KB 0755
flock File 23.88 KB 0755
fmt File 36.48 KB 0755
fold File 36.46 KB 0755
fonttosfnt File 35.99 KB 0755
free File 19.33 KB 0755
freetype-config File 4.39 KB 0755
fribidi File 16.09 KB 0755
ftp File 85.5 KB 0755
ftp-rfc File 683 B 0755
funzip File 31.38 KB 0755
g++ File 754.59 KB 0755
gapplication File 19.48 KB 0755
gawk File 418.55 KB 0755
gcc File 750.59 KB 0755
gcc-ar File 26.45 KB 0755
gcc-nm File 26.45 KB 0755
gcc-ranlib File 26.45 KB 0755
gcov File 307.45 KB 0755
gd2copypal File 7.06 KB 0755
gd2togif File 7.05 KB 0755
gd2topng File 11.06 KB 0755
gdbus File 40.17 KB 0755
gdcmpgif File 11.08 KB 0755
gdk-pixbuf-query-loaders-64 File 15.38 KB 0755
gdk-pixbuf-thumbnailer File 15.59 KB 0755
gdlib-config File 2.52 KB 0755
gdparttopng File 11.07 KB 0755
gdtopng File 7.04 KB 0755
gencat File 22.11 KB 0755
genl-ctrl-list File 11.27 KB 0755
geoiplookup File 15.28 KB 0755
geoiplookup6 File 11.16 KB 0755
geoipupdate File 31.28 KB 0755
geqn File 144.41 KB 0755
getconf File 22.02 KB 0755
getent File 26.39 KB 0755
getfacl File 24.29 KB 0755
getkeycodes File 11.16 KB 0755
getopt File 15.38 KB 0755
getopts File 31 B 0755
gettext File 35.94 KB 0755
gettext.sh File 4.52 KB 0755
gettextize File 42.69 KB 0755
ghostscript File 10.97 KB 0755
giftogd2 File 7.05 KB 0755
gio File 73.41 KB 0755
gio-querymodules-64 File 11.31 KB 0755
git File 1.46 MB 0755
git-receive-pack File 1.46 MB 0755
git-shell File 722.04 KB 0755
git-upload-archive File 1.46 MB 0755
git-upload-pack File 795.48 KB 0755
glib-compile-schemas File 44.38 KB 0755
gmake File 178.47 KB 0755
gneqn File 271 B 0755
gnroff File 3.31 KB 0755
gpasswd File 76.57 KB 4755
gpg File 732.4 KB 0755
gpg-agent File 289.74 KB 0755
gpg-connect-agent File 152.69 KB 0755
gpg-error File 23.18 KB 0755
gpg-error-config File 1.83 KB 0755
gpg-zip File 3.23 KB 0755
gpg2 File 732.4 KB 0755
gpgconf File 140.31 KB 0755
gpgparsemail File 23.7 KB 0755
gpgsplit File 48.88 KB 0755
gpgv File 345.38 KB 0755
gpgv2 File 345.38 KB 0755
gpic File 180.41 KB 0755
gprof File 98.41 KB 0755
gr2fonttest File 23.66 KB 0755
grep File 155.3 KB 0755
groff File 81.63 KB 0755
grops File 140.85 KB 0755
grotty File 98.59 KB 0755
groups File 32.41 KB 0755
grub2-editenv File 396.07 KB 0755
grub2-file File 834.34 KB 0755
grub2-fstest File 1.03 MB 0755
grub2-glue-efi File 258.84 KB 0755
grub2-kbdcomp File 1.63 KB 0755
grub2-menulst2cfg File 241.85 KB 0755
grub2-mkfont File 287.58 KB 0755
grub2-mkimage File 379.21 KB 0755
grub2-mklayout File 264.9 KB 0755
grub2-mknetdir File 429.8 KB 0755
grub2-mkpasswd-pbkdf2 File 271.29 KB 0755
grub2-mkrelpath File 258.48 KB 0755
grub2-mkrescue File 1021.84 KB 0755
grub2-mkstandalone File 534.33 KB 0755
grub2-render-label File 839.14 KB 0755
grub2-script-check File 295.41 KB 0755
grub2-syslinux2cfg File 763.57 KB 0755
gs File 10.97 KB 0755
gsbj File 350 B 0755
gsdj File 352 B 0755
gsdj500 File 352 B 0755
gsettings File 23.8 KB 0755
gslj File 353 B 0755
gslp File 350 B 0755
gsnd File 277 B 0755
gsoelim File 32.59 KB 0755
gss-client File 23.17 KB 0755
gtar File 338.02 KB 0755
gtbl File 115.96 KB 0755
gtroff File 512.96 KB 0755
gunzip File 2.2 KB 0755
gzexe File 5.79 KB 0755
gzip File 98.43 KB 0755
h2ph File 27.65 KB 0755
h2xs File 59.15 KB 0755
hdsploader File 11.18 KB 0755
head File 40.51 KB 0755
hexdump File 32.02 KB 0755
hmac256 File 15.67 KB 0755
host File 127.02 KB 0755
hostid File 28.32 KB 0755
hostname File 15.41 KB 0755
hostnamectl File 318.07 KB 0755
htdbm File 56.14 KB 0755
htdigest File 29.35 KB 0755
htpasswd File 54.2 KB 0755
httxt2dbm File 21.69 KB 0755
hunspell File 53.11 KB 0755
i386 File 15.27 KB 0755
iceauth File 31.73 KB 0755
iconv File 58.14 KB 0755
id File 36.52 KB 0755
ident File 110.45 KB 0755
identify File 7.06 KB 0755
idiag-socket-details File 11.34 KB 0755
idle File 93 B 0755
idn File 32.45 KB 0755
ifnames File 4.03 KB 0755
igawk File 3.11 KB 0755
imapsync File 338.75 KB 0755
import File 7.05 KB 0755
imunify-antivirus File 1 KB 0755
imunify-service File 1023 B 0755
imunify360-agent File 1 KB 0755
imunify360-command-wrapper File 8.35 KB 0755
info File 265.19 KB 0755
infocmp File 56.07 KB 0755
infokey File 21.47 KB 0755
infotocap File 64.26 KB 0755
innochecksum File 4.68 MB 0755
install File 139.59 KB 0755
install-tools File 4.06 KB 0755
instmodsh File 4.15 KB 0755
ionice File 23.86 KB 0755
iostat File 60.79 KB 0755
ipcalc File 15.05 KB 0755
ipcmk File 24 KB 0755
ipcrm File 27.85 KB 0755
ipcs File 48.37 KB 0755
iptables-xml File 91.52 KB 0755
isc-config.sh File 3.47 KB 0755
isosize File 23.83 KB 0755
ispell File 988 B 0755
isql File 31.69 KB 0755
iusql File 23.61 KB 0755
jobs File 28 B 0755
join File 48.75 KB 0755
journalctl File 537.88 KB 0755
jq File 23.61 KB 0755
js File 3.36 MB 0755
json_pp File 3.82 KB 0755
json_reformat File 35.89 KB 0755
json_verify File 27.52 KB 0755
json_xs File 6.74 KB 0755
kbd_mode File 11.16 KB 0755
kbdinfo File 11.19 KB 0755
kbdrate File 11.22 KB 0755
kcare-scanner-interface File 4.56 KB 0755
kcare-uname File 571 B 0755
kcarectl File 1.21 KB 0755
kdumpctl File 33.18 KB 0755
kernel-install File 4.7 KB 0755
keyctl File 27.94 KB 0755
kibitz File 10.63 KB 0755
kill File 32.82 KB 0755
killall File 24.14 KB 0755
kmod File 143.24 KB 0755
krb5-config File 6.96 KB 0755
last File 19.11 KB 0755
lastb File 19.11 KB 0755
lastlog File 19.15 KB 0755
lchfn File 15.52 KB 0755
lchsh File 15.49 KB 0755
ld File 982.58 KB 0755
ld.bfd File 982.58 KB 0755
ld.gold File 5.11 MB 0755
ldd File 5.18 KB 0755
less File 154.57 KB 0755
lessecho File 11.13 KB 0755
lesskey File 16.67 KB 0755
lesspipe.sh File 2.24 KB 0755
lex File 318.07 KB 0755
lexgrog File 85.09 KB 0755
libcare-cron File 1.06 KB 0755
libgcrypt-config File 3.78 KB 0755
libnetcfg File 15.36 KB 0755
libpng-config File 2.38 KB 0755
libpng15-config File 2.38 KB 0755
libtool File 314.04 KB 0755
libtoolize File 76.8 KB 0755
libwmf-fontmap File 12.78 KB 0755
link File 28.3 KB 0755
links File 1.3 MB 0755
linux-boot-prober File 5.85 KB 0755
linux32 File 15.27 KB 0755
linux64 File 15.27 KB 0755
ln File 57.22 KB 0755
loadkeys File 110.48 KB 0755
loadunimap File 23.88 KB 0755
locale File 37.11 KB 0755
localectl File 326.23 KB 0755
localedef File 318.31 KB 0755
logger File 28.62 KB 0755
login File 36.38 KB 0755
loginctl File 489.6 KB 0755
logname File 28.31 KB 0755
logresolve File 28.58 KB 0755
look File 11.27 KB 0755
lprsetup.sh File 5.34 KB 0755
lpunlock File 2.56 KB 0755
ls File 114.85 KB 0755
lsattr File 11.25 KB 0755
lsblk File 79.17 KB 0755
lscpu File 60.75 KB 0755
lsinitrd File 6.26 KB 0755
lsipc File 60.95 KB 0755
lslocks File 41.01 KB 0755
lslogins File 52.88 KB 0755
lsmem File 40.78 KB 0755
lsns File 36.43 KB 0755
lsphp File 937 B 0755
lsscsi File 56.48 KB 0755
lua File 15.47 KB 0755
luac File 119.03 KB 0755
lwp-download File 8.43 KB 0755
lwp-dump File 2.73 KB 0755
lwp-mirror File 2.42 KB 0755
lwp-request File 14.71 KB 0755
lynx File 1.43 MB 0755
lz4 File 105.87 KB 0755
lz4c File 105.87 KB 0755
lz4cat File 105.87 KB 0755
m4 File 151.17 KB 0755
machinectl File 533.93 KB 0755
mail File 383.67 KB 0755
mailx File 383.67 KB 0755
make File 178.47 KB 0755
makedb File 18.11 KB 0755
man File 100.44 KB 0755
mandb File 122.25 KB 0755
manpath File 32.55 KB 0755
mapscrn File 19.78 KB 0755
mcookie File 15.44 KB 0755
md5sum File 40.53 KB 0755
mdig File 44.2 KB 0755
merge File 110.43 KB 0755
mesg File 10.98 KB 0755
mixartloader File 15.38 KB 0755
mkdir File 77.9 KB 0755
mkfifo File 61.59 KB 0755
mkfontdir File 65 B 0755
mkfontscale File 32.48 KB 0755
mkinitrd File 2.94 KB 0755
mknod File 65.61 KB 0755
mkpasswd File 5.56 KB 0755
mktemp File 40.66 KB 0755
modutil File 165.78 KB 0755
mogrify File 7.05 KB 0755
montage File 7.05 KB 0755
more File 40.15 KB 0755
mount File 43.23 KB 4755
mountpoint File 15.32 KB 0755
mpstat File 56.54 KB 0755
msgattrib File 23.36 KB 0755
msgcat File 23.34 KB 0755
msgcmp File 23.59 KB 0755
msgcomm File 19.31 KB 0755
msgconv File 19.3 KB 0755
msgen File 19.3 KB 0755
msgexec File 15.33 KB 0755
msgfilter File 27.56 KB 0755
msgfmt File 77.05 KB 0755
msgfmt.py File 6.33 KB 0755
msggrep File 35.97 KB 0755
msghack File 12.45 KB 0755
msginit File 44.38 KB 0755
msgmerge File 52.6 KB 0755
msgunfmt File 31.7 KB 0755
msguniq File 19.31 KB 0755
msql2mysql File 1.91 KB 0755
mv File 127.3 KB 0755
my_print_defaults File 4.62 MB 0755
myisam_ftdump File 7.17 MB 0755
myisamchk File 7.72 MB 0755
myisamlog File 6.86 MB 0755
myisampack File 7.29 MB 0755
mysql File 6.96 MB 0755
mysql_client_test File 8.05 MB 0755
mysql_client_test_embedded File 88.05 MB 0755
mysql_config File 6.92 KB 0755
mysql_config_editor File 5.86 MB 0755
mysql_convert_table_format File 4.61 KB 0755
mysql_find_rows File 3.7 KB 0755
mysql_fix_extensions File 1.69 KB 0755
mysql_install_db File 34.21 KB 0755
mysql_plugin File 4.68 MB 0755
mysql_secure_installation File 10.28 KB 0755
mysql_setpermission File 17.53 KB 0755
mysql_tzinfo_to_sql File 4.38 MB 0755
mysql_upgrade File 5.94 MB 0755
mysql_waitpid File 4.62 MB 0755
mysql_zap File 4.26 KB 0755
mysqlaccess File 109.89 KB 0755
mysqlaccess.conf File 1.66 KB 0644
mysqladmin File 5.81 MB 0755
mysqlbinlog File 6.71 MB 0755
mysqlbug File 11.32 KB 0755
mysqlcheck File 5.79 MB 0755
mysqld_multi File 26.29 KB 0755
mysqld_safe File 26.01 KB 0755
mysqldump File 6.13 MB 0755
mysqldumpslow File 7.64 KB 0755
mysqlhotcopy File 34.51 KB 0755
mysqlimport File 5.8 MB 0755
mysqlshow File 5.79 MB 0755
mysqlslap File 5.87 MB 0755
mysqltest File 6.62 MB 0755
mysqltest_embedded File 86.25 MB 0755
nail File 383.67 KB 0755
named-rrchecker File 15.32 KB 0755
namei File 27.95 KB 0755
nano File 201.08 KB 0755
nc File 371.27 KB 0755
ncat File 371.27 KB 0755
ncdu File 76.88 KB 0755
ncurses5-config File 5.68 KB 0755
ncursesw5-config File 5.68 KB 0755
ndptool File 23.63 KB 0755
needs-restarting File 8.17 KB 0755
neqn File 271 B 0755
net-snmp-create-v3-user File 2.98 KB 0755
netstat File 151.38 KB 0755
nettle-hash File 11.33 KB 0755
nettle-lfib-stream File 7.05 KB 0755
newgidmap File 38.09 KB 0755
newgrp File 40.95 KB 4755
newuidmap File 38.06 KB 0755
nf-ct-add File 11.8 KB 0755
nf-ct-list File 15.84 KB 0755
nf-exp-add File 16.21 KB 0755
nf-exp-delete File 15.99 KB 0755
nf-exp-list File 11.8 KB 0755
nf-log File 11.23 KB 0755
nf-monitor File 11.18 KB 0755
nf-queue File 11.27 KB 0755
nfsiostat-sysstat File 52.55 KB 0755
ngettext File 35.95 KB 0755
nice File 32.32 KB 0755
nisdomainname File 15.41 KB 0755
nl File 40.6 KB 0755
nl-addr-add File 11.65 KB 0755
nl-addr-delete File 11.73 KB 0755
nl-addr-list File 15.88 KB 0755
nl-class-add File 11.7 KB 0755
nl-class-delete File 11.55 KB 0755
nl-class-list File 11.48 KB 0755
nl-classid-lookup File 11.29 KB 0755
nl-cls-add File 11.76 KB 0755
nl-cls-delete File 11.68 KB 0755
nl-cls-list File 11.58 KB 0755
nl-fib-lookup File 11.41 KB 0755
nl-link-enslave File 7.05 KB 0755
nl-link-ifindex2name File 7.06 KB 0755
nl-link-list File 11.52 KB 0755
nl-link-name2ifindex File 7.05 KB 0755
nl-link-release File 7.05 KB 0755
nl-link-set File 11.64 KB 0755
nl-link-stats File 11.39 KB 0755
nl-list-caches File 11.08 KB 0755
nl-list-sockets File 7.06 KB 0755
nl-monitor File 11.2 KB 0755
nl-neigh-add File 11.51 KB 0755
nl-neigh-delete File 11.57 KB 0755
nl-neigh-list File 11.46 KB 0755
nl-neightbl-list File 11.27 KB 0755
nl-pktloc-lookup File 11.36 KB 0755
nl-qdisc-add File 11.6 KB 0755
nl-qdisc-delete File 11.54 KB 0755
nl-qdisc-list File 11.63 KB 0755
nl-route-add File 11.73 KB 0755
nl-route-delete File 15.86 KB 0755
nl-route-get File 11.18 KB 0755
nl-route-list File 11.77 KB 0755
nl-rule-list File 11.3 KB 0755
nl-tctree-list File 11.53 KB 0755
nl-util-addr File 7.03 KB 0755
nm File 45.43 KB 0755
nm-online File 15.16 KB 0755
nmcli File 809.16 KB 0755
nmtui File 646.77 KB 0755
nmtui-connect File 646.77 KB 0755
nmtui-edit File 646.77 KB 0755
nmtui-hostname File 646.77 KB 0755
nohup File 32.42 KB 0755
nproc File 32.37 KB 0755
nroff File 3.31 KB 0755
nsenter File 28.22 KB 0755
nslookup File 130.93 KB 0755
nss-policy-check File 15.26 KB 0755
nsupdate File 65.2 KB 0755
numfmt File 64.71 KB 0755
objcopy File 227.34 KB 0755
objdump File 357.76 KB 0755
od File 64.81 KB 0755
odbc_config File 11.04 KB 0755
odbcinst File 27.69 KB 0755
oldfind File 186.41 KB 0755
open File 19.48 KB 0755
openssl File 542.27 KB 0755
openvt File 19.48 KB 0755
os-prober File 5.51 KB 0755
p11-kit File 32.18 KB 0755
package-cleanup File 17.39 KB 0755
page_owner_sort File 10.2 KB 0755
pango-list File 11.1 KB 0755
pango-querymodules-64 File 28.26 KB 0755
pango-view File 49.47 KB 0755
paperconf File 11.23 KB 0755
passmass File 4.63 KB 0755
passwd File 27.2 KB 4755
paste File 32.34 KB 0755
patch File 147 KB 0755
pathchk File 32.31 KB 0755
pchrt File 3.93 KB 0755
pcre-config File 2.09 KB 0755
pdf2dsc File 698 B 0755
pdf2ps File 909 B 0755
peekfd File 11.21 KB 0755
perl File 11.14 KB 0755
perl5.16.3 File 11.14 KB 0755
perlbug File 43.61 KB 0755
perldoc File 203 B 0755
perlivp File 10.52 KB 0755
perlml File 5.98 KB 0755
perlthanks File 43.61 KB 0755
perror File 4.73 MB 0755
pf2afm File 498 B 0755
pfbtopfa File 516 B 0755
pflags File 2.06 KB 0755
pftp File 85.5 KB 0755
pgawk File 418.59 KB 0755
pgrep File 27.67 KB 0755
php File 937 B 0755
pic File 180.41 KB 0755
piconv File 7.99 KB 0755
pidstat File 68.91 KB 0755
pinentry File 2.54 KB 0755
pinentry-curses File 49.19 KB 0755
ping File 64.63 KB 0755
ping6 File 64.63 KB 0755
pinky File 36.57 KB 0755
pk12util File 103.22 KB 0755
pkaction File 15 KB 0755
pkcheck File 23.03 KB 0755
pkcs1-conv File 15.52 KB 0755
pkexec File 27.02 KB 4755
pkg-config File 44.38 KB 0755
pkill File 27.67 KB 0755
pkla-admin-identities File 19.23 KB 0755
pkla-check-authorization File 27.3 KB 0755
pkttyagent File 18.98 KB 0755
pl2pm File 4.42 KB 0755
pldd File 14.11 KB 0755
plesk_configure File 450 B 0755
plymouth File 39.77 KB 0755
pmap File 27.61 KB 0755
pngtogd File 7.05 KB 0755
pngtogd2 File 7.05 KB 0755
pod2html File 4 KB 0755
pod2latex File 10.1 KB 0755
pod2man File 13.26 KB 0755
pod2text File 10.75 KB 0755
pod2usage File 3.67 KB 0755
podchecker File 3.7 KB 0755
podselect File 2.55 KB 0755
post-grohtml File 187.55 KB 0755
powernow-k8-decode File 6.15 KB 0755
pphs File 404 B 0755
pr File 65.11 KB 0755
pre-grohtml File 86.24 KB 0755
precat File 5.52 KB 0755
preconv File 40.88 KB 0755
preunzip File 5.52 KB 0755
prezip File 5.52 KB 0755
prezip-bin File 11.05 KB 0755
printafm File 395 B 0755
printenv File 28.28 KB 0755
printf File 48.61 KB 0755
prl_backup File 7.37 KB 0755
prlimit File 41.2 KB 0755
procan File 76.99 KB 0755
prove File 13.13 KB 0755
prtstat File 15.25 KB 0755
ps File 97.77 KB 0755
ps2ascii File 631 B 0755
ps2epsi File 2.69 KB 0755
ps2pdf File 272 B 0755
ps2pdf12 File 215 B 0755
ps2pdf13 File 215 B 0755
ps2pdf14 File 215 B 0755
ps2pdfwr File 1.07 KB 0755
ps2ps File 647 B 0755
ps2ps2 File 669 B 0755
psed File 52.08 KB 0755
psfaddtable File 19.48 KB 0755
psfgettable File 19.48 KB 0755
psfstriptable File 19.48 KB 0755
psfxtable File 19.48 KB 0755
pstree File 27.84 KB 0755
pstree.x11 File 27.84 KB 0755
pstruct File 35.75 KB 0755
ptar File 3.43 KB 0755
ptardiff File 2.41 KB 0755
ptargrep File 4.13 KB 0755
ptaskset File 3.8 KB 0755
ptx File 65.08 KB 0755
pure-pw File 33.97 KB 0755
pure-pwconvert File 9.93 KB 0755
pure-statsdecode File 9.93 KB 0755
pwd File 32.45 KB 0755
pwdx File 11.27 KB 0755
pwmake File 11.13 KB 0755
pwscore File 11.13 KB 0755
pydoc File 78 B 0755
pygettext.py File 21.57 KB 0755
pynche File 137 B 0755
python File 6.98 KB 0755
python-config File 1.79 KB 0755
python2 File 6.98 KB 0755
python2-config File 1.79 KB 0755
python2.7 File 6.98 KB 0755
python2.7-config File 1.79 KB 0755
pyzor File 165 B 0755
pyzor-migrate File 181 B 0755
pyzord File 167 B 0755
qemu-ga File 980.87 KB 0755
quota File 83.31 KB 4755
quotasync File 70.84 KB 0755
ranlib File 61.21 KB 0755
raw File 15.27 KB 0755
rcs File 175.6 KB 0755
rcsclean File 819 B 0755
rcsdiff File 816 B 0755
rcsfreeze File 4.34 KB 0755
rcsmerge File 819 B 0755
rdate File 10.3 KB 0755
read File 28 B 0755
readelf File 509.84 KB 0755
readlink File 40.82 KB 0755
realpath File 61.23 KB 0755
recode-sr-latin File 15.29 KB 0755
rename File 11.26 KB 0755
renice File 11.21 KB 0755
replace File 4.51 MB 0755
repo-graph File 4.09 KB 0755
repo-rss File 10.07 KB 0755
repoclosure File 11.42 KB 0755
repodiff File 13.97 KB 0755
repomanage File 6.88 KB 0755
repoquery File 55.68 KB 0755
reposync File 14.14 KB 0755
repotrack File 9.86 KB 0755
reset File 19.59 KB 0755
resizecons File 19.63 KB 0755
resolve_stack_dump File 4.7 MB 0755
resolveip File 4.62 MB 0755
rev File 11.26 KB 0755
rftp File 8.68 KB 0755
rlog File 807 B 0755
rlogin-cwd File 501 B 0755
rm File 61.4 KB 0755
rmdir File 44.46 KB 0755
rnano File 201.08 KB 0755
rpcgen File 90.45 KB 0755
rpm File 15.75 KB 0755
rpm2cpio File 11.16 KB 0755
rpmdb File 11.73 KB 0755
rpmkeys File 11.73 KB 0755
rpmquery File 15.75 KB 0755
rpmverify File 15.75 KB 0755
rsync File 488.38 KB 0755
rsyslog-recover-qi.pl File 5.96 KB 0755
run-parts File 2.04 KB 0755
run-with-aspell File 85 B 0755
runcon File 32.47 KB 0755
rvi File 906.4 KB 0755
rview File 906.4 KB 0755
rvim File 2.23 MB 0755
s2p File 52.08 KB 0755
sadf File 168.46 KB 0755
sandbox File 17.52 KB 0755
sar File 95.4 KB 0755
scl File 19.5 KB 0755
scl_enabled File 258 B 0755
scl_source File 1.83 KB 0755
scp File 89.23 KB 0755
screen File 464.1 KB 2755
script File 19.61 KB 0755
scriptreplay File 15.29 KB 0755
sdiff File 48.41 KB 0755
secon File 24.06 KB 0755
sed File 74.29 KB 0755
sedismod File 249.42 KB 0755
sedispol File 176.32 KB 0755
semodule_package File 15.3 KB 0755
seq File 48.48 KB 0755
sessreg File 11.24 KB 0755
setarch File 15.27 KB 0755
setfacl File 36.73 KB 0755
setfont File 40.38 KB 0755
setkeycodes File 11.16 KB 0755
setleds File 11.16 KB 0755
setmetamode File 11.21 KB 0755
setpriv File 36.06 KB 0755
setsid File 11.23 KB 0755
setterm File 27.48 KB 0755
setup-nsssysinit File 1.5 KB 0755
setup-nsssysinit.sh File 1.5 KB 0755
setvtrgb File 11.34 KB 0755
sexp-conv File 23.63 KB 0755
sftp File 142.01 KB 0755
sg File 40.95 KB 4755
sh File 941.93 KB 0755
sha1sum File 36.57 KB 0755
sha224sum File 40.63 KB 0755
sha256sum File 40.63 KB 0755
sha384sum File 40.65 KB 0755
sha512sum File 40.65 KB 0755
shar File 154.05 KB 0755
shasum File 8.4 KB 0755
show-changed-rco File 10.13 KB 0755
show-installed File 16.18 KB 0755
showconsolefont File 15.47 KB 0755
showkey File 15.23 KB 0755
showrgb File 7.08 KB 0755
shred File 52.94 KB 0755
shuf File 49.13 KB 0755
signver File 102.6 KB 0755
sim_client File 14.97 KB 0755
size File 32.35 KB 0755
skill File 23.62 KB 0755
slabinfo File 34.96 KB 0755
slabtop File 19.52 KB 0755
sleep File 32.35 KB 0755
slogin File 760.45 KB 0755
smtpd.py File 18.1 KB 0755
snice File 23.62 KB 0755
snmpconf File 25.52 KB 0755
socat File 380.43 KB 0755
soelim File 32.59 KB 0755
sort File 114.94 KB 0755
sotruss File 4.24 KB 0755
spell File 122 B 0755
splain File 18.03 KB 0755
split File 69.47 KB 0755
sprof File 22.1 KB 0755
sqlite3 File 54.95 KB 0755
ssh File 760.45 KB 0755
ssh-add File 352.46 KB 0755
ssh-agent File 373.25 KB 2111
ssh-copy-id File 10.22 KB 0755
ssh-keygen File 409.38 KB 0755
ssh-keyscan File 434.7 KB 0755
ssltap File 118.41 KB 0755
stat File 77.19 KB 0755
stdbuf File 64.88 KB 0755
strace File 1009.22 KB 0755
strace-log-merge File 1.28 KB 0755
stream File 7.05 KB 0755
strings File 36.53 KB 0755
strip File 227.32 KB 0755
stty File 68.61 KB 0755
su File 31.38 KB 4750
sudo File 147.88 KB 4111
sudoedit File 147.88 KB 4111
sudoreplay File 56.11 KB 0111
sum File 36.55 KB 0755
sw-engine File 22.34 MB 0755
sxpm File 19.83 KB 0755
sync File 28.33 KB 0755
systemctl File 704.8 KB 0755
systemd-analyze File 1.49 MB 0755
systemd-ask-password File 60.38 KB 0755
systemd-cat File 39.98 KB 0755
systemd-cgls File 326.31 KB 0755
systemd-cgtop File 85.09 KB 0755
systemd-coredumpctl File 154.52 KB 0755
systemd-delta File 76.84 KB 0755
systemd-detect-virt File 39.97 KB 0755
systemd-escape File 48.2 KB 0755
systemd-firstboot File 101.52 KB 0755
systemd-hwdb File 85.31 KB 0755
systemd-inhibit File 309.83 KB 0755
systemd-loginctl File 489.6 KB 0755
systemd-machine-id-setup File 52.23 KB 0755
systemd-notify File 48.13 KB 0755
systemd-nspawn File 545.88 KB 0755
systemd-path File 52.16 KB 0755
systemd-run File 387.05 KB 0755
systemd-stdio-bridge File 305.77 KB 0755
systemd-sysv-convert File 3.89 KB 0755
systemd-tmpfiles File 146.13 KB 0755
systemd-tty-ask-password-agent File 84.75 KB 0755
tabs File 15.3 KB 0755
tac File 32.48 KB 0755
tail File 65.25 KB 0755
tailf File 23.88 KB 0755
tapestat File 52.56 KB 0755
tar File 338.02 KB 0755
taskset File 32.22 KB 0755
tbl File 115.96 KB 0755
tcamgr File 23.47 KB 0755
tcamttest File 19.37 KB 0755
tcatest File 52.78 KB 0755
tcbmgr File 27.66 KB 0755
tcbmttest File 47.96 KB 0755
tcbtest File 64.47 KB 0755
tcfmgr File 19.5 KB 0755
tcfmttest File 31.79 KB 0755
tcftest File 43.86 KB 0755
tchmgr File 23.52 KB 0755
tchmttest File 43.87 KB 0755
tchtest File 52.29 KB 0755
tclsh File 7 KB 0755
tclsh8.5 File 7 KB 0755
tcptraceroute File 1.44 KB 0755
tctmgr File 31.82 KB 0755
tctmttest File 39.72 KB 0755
tcttest File 51.9 KB 0755
tcucodec File 31.75 KB 0755
tcumttest File 19.52 KB 0755
tcutest File 65.61 KB 0755
teamd File 155.09 KB 0755
teamdctl File 28.98 KB 0755
teamnl File 19.09 KB 0755
tee File 32.38 KB 0755
test File 36.46 KB 0755
testgdbm File 29.77 KB 0755
tic File 64.26 KB 0755
timed-read File 303 B 0755
timed-run File 277 B 0755
timedatectl File 330.2 KB 0755
timeout File 53.31 KB 0755
tload File 15.38 KB 0755
tmon File 31.11 KB 0755
tmpwatch File 27.87 KB 0755
toe File 15.42 KB 0755
top File 104.38 KB 0755
touch File 61.02 KB 0755
tput File 15.43 KB 0755
tr File 44.61 KB 0755
tracepath File 15.05 KB 0755
tracepath6 File 15.05 KB 0755
traceroute File 61.86 KB 0755
traceroute6 File 61.86 KB 0755
troff File 512.96 KB 0755
true File 28.26 KB 0755
truncate File 52.68 KB 0755
trust File 179.08 KB 0755
tset File 19.59 KB 0755
tsort File 36.47 KB 0755
tty File 28.29 KB 0755
turbostat File 113.15 KB 0755
tzselect File 7.17 KB 0755
uapi File 3.02 MB 0755
ucs2any File 19.47 KB 0755
udevadm File 414.27 KB 0755
ul File 19.47 KB 0755
umask File 29 B 0755
umount File 31.23 KB 4755
unalias File 31 B 0755
uname File 32.3 KB 0755
unbuffer File 640 B 0755
unexpand File 32.45 KB 0755
unicode_start File 2.5 KB 0755
unicode_stop File 363 B 0755
uniq File 44.71 KB 0755
unix-lpr.sh File 4.07 KB 0755
unlink File 28.3 KB 0755
unlz4 File 105.87 KB 0755
unshar File 108.52 KB 0755
unshare File 15.45 KB 0755
unxz File 73.52 KB 0755
unzip File 185.16 KB 0755
unzipsfx File 88.66 KB 0755
update-ca-trust File 1.03 KB 0755
update-mime-database File 52.82 KB 0755
uptime File 11.22 KB 0755
urlgrabber File 12.17 KB 0755
users File 32.42 KB 0755
usleep File 10.95 KB 0755
usx2yloader File 15.41 KB 0755
utmpdump File 15.45 KB 0755
uuclient File 14.97 KB 0755
uudecode File 103.99 KB 0755
uuencode File 103.98 KB 0755
uuidgen File 11.21 KB 0755
vdir File 114.85 KB 0755
verifytree File 10.79 KB 0755
vi File 906.4 KB 0755
view File 906.4 KB 0755
vim File 2.23 MB 0755
vimdiff File 2.23 MB 0755
vimtutor File 2.04 KB 0755
vlock File 15.73 KB 0755
vmstat File 31.48 KB 0755
vxloader File 15.38 KB 0755
w File 19.45 KB 0755
wait File 28 B 0755
wall File 14.98 KB 2555
watch File 24.14 KB 0755
watchgnupg File 15.35 KB 0755
wc File 40.67 KB 0755
wdctl File 40.7 KB 0755
weather File 2.18 KB 0755
webpng File 11.15 KB 0755
wget File 408.97 KB 0755
whatis File 45.49 KB 0755
whereis File 20.2 KB 0755
which File 23.77 KB 0755
whiptail File 27.84 KB 0755
who File 48.7 KB 0755
whoami File 28.3 KB 0755
wish File 7.04 KB 0755
wish8.5 File 7.04 KB 0755
wmf2eps File 15.29 KB 0755
wmf2fig File 15.27 KB 0755
wmf2gd File 15.26 KB 0755
wmf2svg File 15.3 KB 0755
wmf2x File 15.25 KB 0755
word-list-compress File 11.03 KB 0755
write File 19.09 KB 2755
x86_64 File 15.27 KB 0755
x86_64-redhat-linux-c++ File 754.59 KB 0755
x86_64-redhat-linux-g++ File 754.59 KB 0755
x86_64-redhat-linux-gcc File 750.59 KB 0755
x86_energy_perf_policy File 10.23 KB 0755
xargs File 60.91 KB 0755
xgamma File 11.15 KB 0755
xgettext File 265.35 KB 0755
xhost File 15.38 KB 0755
xinput File 52.81 KB 0755
xkibitz File 4.75 KB 0755
xkill File 15.27 KB 0755
xml2-config File 1.68 KB 0755
xmlcatalog File 15.3 KB 0755
xmllint File 61.94 KB 0755
xmlwf File 24 KB 0755
xmodmap File 32.28 KB 0755
xorg-x11-fonts-update-dirs File 1.29 KB 0744
xrandr File 60.06 KB 0755
xrdb File 27.78 KB 0755
xrefresh File 11.16 KB 0755
xset File 31.72 KB 0755
xsetmode File 11.1 KB 0755
xsetpointer File 11.13 KB 0755
xsetroot File 19.38 KB 0755
xslt-config File 2.36 KB 0755
xsltproc File 23.5 KB 0755
xstdcmap File 15.77 KB 0755
xsubpp File 4.45 KB 0755
xxd File 14.42 KB 0755
xz File 73.52 KB 0755
xzcat File 73.52 KB 0755
xzcmp File 6.48 KB 0755
xzdec File 11.21 KB 0755
xzdiff File 6.48 KB 0755
xzegrep File 5.76 KB 0755
xzfgrep File 5.76 KB 0755
xzgrep File 5.76 KB 0755
xzless File 1.76 KB 0755
xzmore File 2.11 KB 0755
yes File 28.3 KB 0755
ypdomainname File 15.41 KB 0755
yum File 801 B 0755
yum-builddep File 9.95 KB 0755
yum-config-manager File 9.35 KB 0755
yum-debug-dump File 8.34 KB 0755
yum-debug-restore File 7.72 KB 0755
yum-groups-manager File 10.77 KB 0755
yumdownloader File 10.85 KB 0755
zcat File 1.9 KB 0755
zcmp File 1.72 KB 0755
zdiff File 5.63 KB 0755
zegrep File 123 B 0755
zfgrep File 123 B 0755
zforce File 2.09 KB 0755
zgrep File 5.98 KB 0755
zip File 210.78 KB 0755
zipcloak File 98.1 KB 0755
zipcmp File 11.71 KB 0755
zipdetails File 47.32 KB 0755
zipgrep File 2.88 KB 0755
zipinfo File 185.16 KB 0755
zipmerge File 11.76 KB 0755
zipnote File 93.73 KB 0755
zipsplit File 97.75 KB 0755
ziptorrent File 11.6 KB 0755
zless File 1.99 KB 0755
zmore File 2.79 KB 0755
znew File 5.22 KB 0755
zsh File 723.13 KB 0755
zsoelim File 32.59 KB 0755